VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cRegion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
' Region
'
' Point = (Word)X (Word)Y
'       = Y*65536+X

Private Declare Sub CopyMemory _
  Lib "kernel32" Alias "RtlMoveMemory" _
  (ByRef lpvDest As Any, ByRef lpvSource As Any, _
   ByVal cbCopy As Long)

Private Type POINTAPI
  x As Long
  y As Long
End Type

Private Const POLY_ALTERNATE = 1
Private Const POLY_WINDING = 2

Private Declare Function CreateRectRgn _
  Lib "gdi32" _
  (ByVal x1 As Long, ByVal y1 As Long, _
   ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CreateEllipticRgn _
  Lib "gdi32" _
  (ByVal x1 As Long, ByVal y1 As Long, _
   ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CreatePolygonRgn _
  Lib "gdi32" _
  (ByRef lpPoint As POINTAPI, _
   ByVal nCount As Long, _
   ByVal nPolyFillMode As Long) As Long
Private Declare Function DeleteObject _
  Lib "gdi32" _
  (ByVal hObject As Long) As Long
Private Declare Function PtInRegion _
  Lib "gdi32" _
  (ByVal hRgn As Long, _
   ByVal x As Long, ByVal y As Long) As Long
   
Private Declare Function Rectangle _
  Lib "gdi32" _
  (ByVal hdc As Long, _
   ByVal x1 As Long, ByVal y1 As Long, _
   ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function Ellipse _
  Lib "gdi32" _
  (ByVal hdc As Long, _
   ByVal x1 As Long, ByVal y1 As Long, _
   ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function Polygon _
  Lib "gdi32" _
  (ByVal hdc As Long, _
   lpPoint As POINTAPI, ByVal nCount As Long) As Long
   
Public Enum RGN_TYP
  RGN_RECT = 0
  RGN_ROUND
  RGN_POLY
End Enum

Public Enum RGN_ADDPOINT
  RGN_ADD = -1
End Enum

Private MyHandle As Long  'Handle der API-Region
Private MyTyp As RGN_TYP
Private MyTitle As String
Private MyTag As String
Private MyPoint() As POINTAPI
Private MyPoints As Long


'==== PUBLIC ====================

'---- EDIT --------------------

Public Property Let Typ(ByVal NewTyp As RGN_TYP)
  Dim b As Boolean
  '
  If (NewTyp < 0) Then NewTyp = 0 'Clippen
  If (NewTyp > 2) Then NewTyp = 2
  If (NewTyp = MyTyp) Then Exit Property
  '---- evtl. Region konvertieren
  If (NewTyp = RGN_POLY) Then
    If (MyTyp = RGN_RECT) Then
      Rect2Poly
    Else
      Round2Poly
    End If
  ElseIf (MyTyp = RGN_POLY) Then
    Poly2Rect
  End If
  MyTyp = NewTyp
  UpdateRegion
End Property
Public Property Get Typ() As RGN_TYP
  Typ = MyTyp
End Property

Public Property Let Title(ByVal NewTitle As String)
  MyTitle = NewTitle
End Property
Public Property Get Title() As String
  Title = MyTitle
End Property

Public Property Let Tag(ByVal NewTag As String)
  MyTag = NewTag
End Property
Public Property Get Tag() As String
  Tag = MyTag
End Property

Public Sub GetPoint(ByVal Index As Long, _
                    ByRef x As Long, _
                    ByRef y As Long)
'Punkt holen
  If (Index > MyPoints - 1) Then Exit Sub
  If (Index < 0) Then Exit Sub
  x = MyPoint(Index).x
  y = MyPoint(Index).y
End Sub

Public Sub SetPoint(ByVal Index As Long, _
                    ByVal x As Long, _
                    ByVal y As Long)
'Punkt holen
  If (Index > MyPoints - 1) Then Exit Sub
  If (Index < 0) Then Exit Sub
  MyPoint(Index).x = x
  MyPoint(Index).y = y
  UpdateRegion
End Sub

'---- RGN_RECT/RGN_CIRCLE --------------------

Public Sub SetRect(ByVal x1 As Long, _
                   ByVal y1 As Long, _
                   ByVal x2 As Long, _
                   ByVal y2 As Long)
'Gre festlegen
  If (MyTyp = RGN_POLY) Then Exit Sub
  MyPoint(0).x = x1: MyPoint(0).y = y1
  MyPoint(1).x = x2: MyPoint(1).y = y2
  UpdateRegion
End Sub

Public Sub GetRect(ByRef x1 As Long, _
                   ByRef y1 As Long, _
                   ByRef x2 As Long, _
                   ByRef y2 As Long)
'Gre holen
  GetBoundRect x1, y1, x2, y2
End Sub

'---- RGN_POLY --------------------

Public Property Get Points() As Long
'Anzahl der Punkte holen
  Points = MyPoints
End Property

Public Sub AddPoint(ByVal x As Long, _
                    ByVal y As Long, _
                    Optional ByVal Index As RGN_ADDPOINT = RGN_ADD)
'Punkt hinzufgen/einfgen
  Dim i As Long
  '
  If Not (MyTyp = RGN_POLY) Then Exit Sub
  If (Index > MyPoints - 1) Then Exit Sub 'falscher index
  ReDim Preserve MyPoint(MyPoints) 'Platz schaffen
  If (Index = RGN_ADD) Then 'hinzufgen
    i = MyPoints 'letzte Position
  Else 'einfgen
    i = VarPtr(MyPoint(Index))
    CopyMemory ByVal (i + 8), ByVal i, _
               (MyPoints - Index) * 8
    i = Index
  End If
  '---- Punkt aufnehmen
  MyPoint(i).x = x: MyPoint(i).y = y
  MyPoints = MyPoints + 1
  UpdateRegion
End Sub

Public Sub DeletePoint(ByVal Index As Long)
'Punkt Nr.n lschen
  Dim i As Long
  '
  If Not (MyTyp = RGN_POLY) Then Exit Sub
  If (MyPoints < 4) Then Exit Sub 'mind.3 Punkte
  If (Index < 0) Then Exit Sub 'falscher index
  If (Index > MyPoints - 1) Then Exit Sub 'falscher index
  '---- Daten verschieben
  MyPoints = MyPoints - 1
  If (MyPoints > Index) Then
    i = VarPtr(MyPoint(Index))
    CopyMemory ByVal i, ByVal (i + 8), _
               (MyPoints - Index) * 8
  End If
  ReDim Preserve MyPoint(MyPoints - 1)
  UpdateRegion
End Sub

'---- USE --------------------

Public Sub Move(ByVal Xdiff As Long, _
                ByVal Ydiff As Long)
  Dim i As Long
  '
  For i = 0 To MyPoints - 1
    MyPoint(i).x = MyPoint(i).x + Xdiff
    MyPoint(i).y = MyPoint(i).y + Ydiff
  Next
  UpdateRegion
End Sub

Public Sub Copy(ByVal region As cRegion, _
                ByVal Xdiff As Long, _
                ByVal Ydiff As Long)
'bernimmt Eigenschaften von region
'mit Positionsversatz Xdiff/Ydiff
  Dim i As Long, x As Long, y As Long
  '
  If (region Is Nothing) Then Exit Sub
  MyPoints = region.Points
  ReDim MyPoint(MyPoints - 1)
  MyTyp = region.Typ
  MyTitle = region.Title
  For i = 0 To region.Points - 1
    region.GetPoint i, x, y
    MyPoint(i).x = x + Xdiff
    MyPoint(i).y = y + Ydiff
  Next
  UpdateRegion
End Sub

Public Sub Draw(ByVal pic As PictureBox, _
                ByVal Factor As Single, _
                ByVal Xoff As Single, ByVal Yoff As Single)
  Dim p() As POINTAPI, i As Long
  '
  Select Case (MyTyp)
    Case RGN_RECT:
      Rectangle pic.hdc, _
                Int((CSng(MyPoint(0).x) - Xoff) * Factor), _
                Int((CSng(MyPoint(0).y) - Yoff) * Factor), _
                Int((CSng(MyPoint(1).x) - Xoff) * Factor), _
                Int((CSng(MyPoint(1).y) - Yoff) * Factor)
    Case RGN_ROUND:
      Ellipse pic.hdc, _
              Int((CSng(MyPoint(0).x) - Xoff) * Factor), _
              Int((CSng(MyPoint(0).y) - Yoff) * Factor), _
              Int((CSng(MyPoint(1).x) - Xoff) * Factor), _
              Int((CSng(MyPoint(1).y) - Yoff) * Factor)
      pic.DrawStyle = vbDot
      Rectangle pic.hdc, _
                Int((CSng(MyPoint(0).x) - Xoff) * Factor), _
                Int((CSng(MyPoint(0).y) - Yoff) * Factor), _
                Int((CSng(MyPoint(1).x) - Xoff) * Factor), _
                Int((CSng(MyPoint(1).y) - Yoff) * Factor)
      pic.DrawStyle = vbSolid
    Case RGN_POLY:
      '---- skalierte Koordinaten erzeugen
      ReDim p(MyPoints - 1)
      For i = 0 To MyPoints - 1
        p(i).x = Int((CSng(MyPoint(i).x) - Xoff) * Factor)
        p(i).y = Int((CSng(MyPoint(i).y) - Yoff) * Factor)
      Next
      Polygon pic.hdc, p(0), MyPoints
  End Select
End Sub

Public Function Hit(ByVal x As Long, _
                    ByVal y As Long) As Boolean
'liefert TRUE, wenn (x/y) in Region
  Hit = Not (PtInRegion(MyHandle, x, y) = 0)
End Function

Public Function HitPoint(ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal diff As Long) As Long
'liefert Index des Punktes, der im Kreis (x/y/diff) liegt
'falls kein Punkt im Kreis: -1
  Dim dx As Single, dy As Single
  '
  For HitPoint = 0 To MyPoints - 1
    dx = Abs(CSng(MyPoint(HitPoint).x) - CSng(x))
    dy = Abs(CSng(MyPoint(HitPoint).y) - CSng(y))
    If ((dx ^ 2 + dy ^ 2) ^ 0.5 <= CSng(diff)) Then Exit Function
  Next
  HitPoint = -1
End Function

Public Sub UpdateRegion()
'API-Region erstellen
  Dim i As Long
  '
  Delete
  '---- Region erstellen
  Select Case (MyTyp)
    Case RGN_RECT:
      MyHandle = CreateRectRgn(MyPoint(0).x, MyPoint(0).y, _
                               MyPoint(1).x, MyPoint(1).y)
    Case RGN_ROUND:
      MyHandle = CreateEllipticRgn(MyPoint(0).x, MyPoint(0).y, _
                                   MyPoint(1).x, MyPoint(1).y)
    Case RGN_POLY:
      MyHandle = CreatePolygonRgn(MyPoint(0), MyPoints, POLY_WINDING)
  End Select
End Sub


'==== STUFF ====================

Private Sub Poly2Rect()
  Dim x1 As Long, y1 As Long, x2 As Long, y2 As Long
  '
  GetBoundRect x1, y1, x2, y2
  ReDim MyPoint(1)
  MyPoint(0).x = x1: MyPoint(0).y = y1
  MyPoint(1).x = x2: MyPoint(1).y = y2
  MyPoints = 2
End Sub

Private Sub Rect2Poly()
'RectBound in Poly verwandeln
'2 Punkte -> 4 Punkte
  ReDim Preserve MyPoint(3)
  MyPoint(3).x = MyPoint(0).x
  MyPoint(3).y = MyPoint(1).y
  MyPoint(2) = MyPoint(1)
  MyPoint(1).y = MyPoint(0).y
  MyPoints = 4
End Sub

Private Sub Round2Poly()
'Round in Poly (Hexagon) verwandeln
'2 Punkte -> 6 Punkte
  Dim x1 As Long, y1 As Long, x2 As Long, y2 As Long
  '
  GetBoundRect x1, y1, x2, y2
  ReDim MyPoint(5)
  MyPoint(0).x = x1 + (x2 - x1) * 0.25: MyPoint(0).y = y1
  MyPoint(1).x = x1 + (x2 - x1) * 0.75: MyPoint(1).y = y1
  MyPoint(2).x = x2: MyPoint(2).y = y1 + (y2 - y1) * 0.5
  MyPoint(3).x = MyPoint(1).x: MyPoint(3).y = y2
  MyPoint(4).x = MyPoint(0).x: MyPoint(4).y = y2
  MyPoint(5).x = x1: MyPoint(5).y = MyPoint(2).y
  MyPoints = 6
End Sub

Private Sub Delete()
  If (MyHandle = 0) Then Exit Sub
  DeleteObject MyHandle
  MyHandle = 0
End Sub

Private Sub GetBoundRect(ByRef x1 As Long, _
                         ByRef y1 As Long, _
                         ByRef x2 As Long, _
                         ByRef y2 As Long)
'umschlieendes Rechteck holen
  Dim i As Long, v As Long
  '
  '---- mit Maximalwerten vorbelegen
  x1 = 32767: x2 = -32768
  y1 = 32767: y2 = -32768
  For i = 0 To MyPoints - 1
    v = MyPoint(i).x
    If (v < x1) Then x1 = v
    If (v > x2) Then x2 = v
    v = MyPoint(i).y
    If (v < y1) Then y1 = v
    If (v > y2) Then y2 = v
  Next
End Sub


'==== CLASS ====================

Private Sub Class_Initialize()
  ReDim MyPoint(1)
  MyPoint(0).x = 0: MyPoint(0).y = 0
  MyPoint(1).x = 32: MyPoint(1).y = 32
  MyPoints = 2
  MyTyp = RGN_RECT
  UpdateRegion
  MyTitle = "Neue Region"
  MyTag = ""
End Sub

Private Sub Class_Terminate()
  Delete
End Sub
