VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IniAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ACHTUNG: Besonderheit bei Fliekommazahlen
'---- Lesen von FLOAT:
' f = Val(MyIni.ReadEntry(SEC_X, KEY_Y, DEF_Y))
'---- Schreiben von FLOAT:
' MyIni.WriteEntry SEC_X, KEY_Y, Trim(Str(f))

Private Declare Function GetPrivateProfileString _
  Lib "kernel32" Alias "GetPrivateProfileStringA" _
  (ByVal lpAppName As String, _
   ByVal lpKeyName As Any, _
   ByVal lpDefault As String, _
   ByVal lpReturnedString As String, _
   ByVal nSize As Long, _
   ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString _
  Lib "kernel32" Alias "WritePrivateProfileStringA" _
  (ByVal lpAppName As String, _
   ByVal lpKeyName As Any, _
   ByVal lpString As Any, _
   ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection _
  Lib "kernel32" Alias "WritePrivateProfileSectionA" _
  (ByVal lpAppName As String, _
   ByVal lpString As String, _
   ByVal lpFileName As String) As Long

Private Const MAXSTRINGLEN As Integer = 260
Private Const DEF_LIM As Byte = 94 'Default Textlimiter = ^
Private MyIniName As String
Private MyString As String


'==== Dateiname ====================

Public Property Let IniFile(ByVal fname As String)
  MyIniName = fname
End Property

Public Property Get IniFile() As String
  IniFile = MyIniName
End Property


'==== Lesen ====================

Public Function ReadEntry(ByVal Section As String, _
                          ByVal Key As String, _
                          ByVal Default As String) As String
  Dim l As Long
  Dim sKey As String
  '
  sKey = Key & Chr(0)
  l = GetPrivateProfileString(Section & Chr(0), _
                              sKey, _
                              Default & Chr(0), _
                              MyString, _
                              MAXSTRINGLEN, _
                              MyIniName & Chr(0))
  '---- String fr VB vorbereiten
  ReadEntry = Trim(Left(MyString, _
    InStr(1, MyString, Chr(0), vbBinaryCompare) - 1))
End Function


'==== Schreiben ====================

Public Sub WriteEntry(ByVal Section As String, _
                      ByVal Key As String, _
                      ByVal Value As String)
  Dim sKey As String
  '
  sKey = Key & Chr(0)
  '---- String clippen
  LSet MyString = Left(Value, MAXSTRINGLEN - 1) & Chr(0)
  Call WritePrivateProfileString(Section & Chr(0), _
                                 sKey, _
                                 MyString, _
                                 MyIniName & Chr(0))
End Sub

Public Sub ClearSection(ByVal Section As String)
'Sektion lschen
  Dim sKey As String
  '
  sKey = String(2, Chr(0))
  Call WritePrivateProfileSection(Section & Chr(0), _
                                  sKey, _
                                  MyIniName & Chr(0))
End Sub


'==== Arrays konvertieren ====================

Public Function Array2String(ByRef ss() As String, _
                             ByVal sep As String, _
                             Optional ByVal txtLim As Byte = DEF_LIM) As String
'StringArray -> StringZeile
'sep' = Separator (normal: Komma)
'txtLim' = ASC-Code des Textlimiters
  Dim i As Integer, s As String
  Dim lim As String
  '
  For i = 0 To UBound(ss())
    If (i > 0) Then Array2String = Array2String & sep 'Separator einfgen
    If IsNumeric(ss(i)) Then
      lim = ""
    Else 'Text in Quotes
      lim = Chr(txtLim)
    End If
    Array2String = Array2String & lim & ss(i) & lim
  Next
End Function

Public Sub String2Array(ByRef ss() As String, _
                        ByVal sep As String, _
                        ByVal s As String, _
                        Optional ByVal txtLim As Byte = DEF_LIM)
'StringZeile -> StringArray
'sep' = 1 Zeichen Separator (normal: Komma)
'txtLim' = ASC-Code des Textlimiters (default: ^ = 94)
  Dim i As Long, p1 As Long, p2 As Long
  Dim pquote As Long
  '
  ReDim ss(0): i = 0
  If (Len(s) = 0) Then Exit Sub
  Do
    p1 = p2 + 1
    p2 = InStr(p1, s, sep)
    pquote = InStr(p1, s, Chr(txtLim))
    If (pquote > 0) And (pquote < p2) Then 'Textbereich
      pquote = InStr(pquote + 1, s, Chr(txtLim))
      '---- Separator hinter dem Textbereich suchen
      If (pquote > 0) Then p2 = InStr(pquote + 1, s, sep)
    End If
    If (p2 = 0) Then p2 = Len(s) + 1
    ReDim Preserve ss(i)
    ss(i) = TrimEx(Mid(s, p1, p2 - p1))
    '---- evtl. Quotes entfernen
    If (Len(ss(i)) > 1) Then
      If (Asc(ss(i)) = txtLim) And _
         (Asc(Right(ss(i), 1)) = txtLim) Then _
        ss(i) = Mid(ss(i), 2, Len(ss(i)) - 2)
    End If
    i = i + 1
  Loop Until (p2 > Len(s))
End Sub


'==== Sektionen/Schlssel-Info ====================

Public Function GetSections(ByVal pattern As String, _
                            ByRef secname() As String) As Long
'liefert die Anzahl der Sektionen, deren Name mit 'pattern'
'bereinstimmt (z.B. "user_*") und speichert sie als 0-basierte
'Liste in secname().
On Error GoTo CLEANUP
  Dim fh As Long, s As String
  '
  GetSections = 0: ReDim secname(0)
  fh = FreeFile
  Open MyIniName For Input As fh
  While Not EOF(fh) '---- Sektion suchen
    Line Input #fh, s: s = Trim(s)
    If (Len(s) > 2) Then
      If (Asc(s) = 91) And (Asc(Right(s, 1)) = 93) Then '[...]
        s = Mid(s, 2, Len(s) - 2) 'Klammern entfernen
        If (s Like pattern) Then 'passende Sektion gefunden
          ReDim Preserve secname(GetSections)
          secname(GetSections) = s
          GetSections = GetSections + 1
        End If
      End If
    End If
  Wend
CLEANUP:
  Close fh
End Function

Public Function GetKeys(ByVal secname As String, _
                        ByRef keyname() As String) As Long
'liefert die Anzahl der Schlssel in Sektion 'secname'
'und speichert sie als 0-basierte Liste in keyname().
On Error GoTo CLEANUP
  Dim fh As Long, s As String, i As Long
  '
  GetKeys = 0: ReDim keyname(0)
  fh = FreeFile
  Open MyIniName For Input As fh
  While Not EOF(fh) '---- Sektion suchen
    Line Input #fh, s: s = Trim(s)
    If (s = "[" & secname & "]") Then 'Sektion gefunden
      While Not EOF(fh) '---- Keys sammeln
        Line Input #fh, s: s = Trim(s)
        If (Len(s) = 0) Then GoTo NEXTLINE 'leere Zeile ""
        If (Asc(s) = 59) Then GoTo NEXTLINE 'Remark-Zeichen ";"
        If (Asc(s) = 91) Then GoTo CLEANUP 'Section-Zeichen "["
        i = InStr(s, "=")
        If (i = 0) Then GoTo NEXTLINE 'fehlende Zuweisung "="
        s = Trim(Left(s, i - 1)) 'Schlssel extrahieren
        ReDim Preserve keyname(GetKeys)
        keyname(GetKeys) = s
        GetKeys = GetKeys + 1
NEXTLINE:
      Wend
    End If
  Wend
CLEANUP:
  Close fh
End Function


'==== STUFF ====================

Private Function TrimEx(ByVal s As String) As String
'Trimmt auch Steuerzeichen
  Dim i As Long, p1 As Long, p2 As Long
  '
  TrimEx = ""
  If (Len(s) = 0) Then Exit Function
  '---- von links
  For p1 = 1 To Len(s)
    If (Asc(Mid(s, p1, 1)) > 32) Then Exit For
  Next
  '---- von rechts
  For p2 = Len(s) To 1 Step -1
    If (Asc(Mid(s, p2, 1)) > 32) Then Exit For
  Next
  If (p1 > p2) Then Exit Function
  If (p1 = p2) Then _
    If (Asc(Mid(s, p1, 1)) <= 32) Then Exit Function
  TrimEx = Mid(s, p1, p2 - p1 + 1)
End Function


'==== CLASS ====================

Private Sub Class_Initialize()
  '---- Textcontainer vorbereiten
  MyString = Space(MAXSTRINGLEN)
End Sub
